package golanghelper

const (
	INDEX_NOT_FOUND = -1
)

type ArrayUtils struct {
}

// 以 startIndex 為起始位置來尋找 value 在 bool array 中的位置
func (a *ArrayUtils) BoolIndexOf(array []bool, value bool, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 byte array 中的位置
func (a *ArrayUtils) ByteIndexOf(array []byte, value byte, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 float32 array 中的位置
func (a *ArrayUtils) Float32IndexOf(array []float32, value float32, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 float64 array 中的位置
func (a *ArrayUtils) Float64IndexOf(array []float64, value float64, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 int8 array 中的位置
func (a *ArrayUtils) Int8IndexOf(array []int8, value int8, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 int16 array 中的位置
func (a *ArrayUtils) Int16IndexOf(array []int16, value int16, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 int32 array 中的位置
func (a *ArrayUtils) Int32IndexOf(array []int32, value int32, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 int64 array 中的位置
func (a *ArrayUtils) Int64IndexOf(array []int64, value int64, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 string array 中的位置
func (a *ArrayUtils) StringIndexOf(array []string, value string, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 uint8 array 中的位置
func (a *ArrayUtils) Uint8IndexOf(array []uint8, value uint8, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 uint16 array 中的位置
func (a *ArrayUtils) Uint16IndexOf(array []uint16, value uint16, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 uint32 array 中的位置
func (a *ArrayUtils) Uint32IndexOf(array []uint32, value uint32, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}

// 以 startIndex 為起始位置來尋找 value 在 uint64 array 中的位置
func (a *ArrayUtils) Uint64IndexOf(array []uint64, value uint64, startIndex int) int {
	if len(array) == 0 {
		return INDEX_NOT_FOUND
	}
	if startIndex < 0 {
		startIndex = 0
	}
	for i := startIndex; i < len(array); i++ {
		if value == array[i] {
			return i
		}
	}
	return INDEX_NOT_FOUND
}
