package golanghelper

import (
	"encoding/json"
)

type JSONObject struct {
	Data []byte
}

func NewJSONObject(object interface{}) (jsonObject JSONObject, err error) {
	var data []byte
	data, err = json.Marshal(object)
	if err != nil {
		return
	}

	jsonObject = JSONObject{Data: data}

	return
}

func (j *JSONObject) ToString() string {
	return string(j.Data)
}
